792c526588924b3cd4d5fd8d2aa5db4e103de18e
[ganeti-github.git] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
27 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
28 CHECK_VERSION = $(top_srcdir)/autotools/check-version
29 CHECK_NEWS = $(top_srcdir)/autotools/check-news
30 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
31 DOCPP = $(top_srcdir)/autotools/docpp
32 REPLACE_VARS_SED = autotools/replace_vars.sed
33 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
34 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
35 SHELL_ENV_INIT = autotools/shell-env-init
36
37 # Note: these are automake-specific variables, and must be named after
38 # the directory + 'dir' suffix
39 clientdir = $(pkgpythondir)/client
40 hypervisordir = $(pkgpythondir)/hypervisor
41 httpdir = $(pkgpythondir)/http
42 masterddir = $(pkgpythondir)/masterd
43 confddir = $(pkgpythondir)/confd
44 rapidir = $(pkgpythondir)/rapi
45 serverdir = $(pkgpythondir)/server
46 watcherdir = $(pkgpythondir)/watcher
47 impexpddir = $(pkgpythondir)/impexpd
48 utilsdir = $(pkgpythondir)/utils
49 toolsdir = $(pkglibdir)/tools
50 iallocatorsdir = $(pkglibdir)/iallocators
51 pytoolsdir = $(pkgpythondir)/tools
52 docdir = $(datadir)/doc/$(PACKAGE)
53 myexeclibdir = $(pkglibdir)
54
55 # Delete output file if an error occurred while building it
56 .DELETE_ON_ERROR:
57
58 HS_DIRS = \
59         src \
60         src/Ganeti \
61         src/Ganeti/Block \
62         src/Ganeti/Block/Drbd \
63         src/Ganeti/Confd \
64         src/Ganeti/DataCollectors \
65         src/Ganeti/HTools \
66         src/Ganeti/HTools/Backend \
67         src/Ganeti/HTools/Program \
68         src/Ganeti/Query \
69         test/hs \
70         test/hs/Test \
71         test/hs/Test/Ganeti \
72         test/hs/Test/Ganeti/Block \
73         test/hs/Test/Ganeti/Block/Drbd \
74         test/hs/Test/Ganeti/Confd \
75         test/hs/Test/Ganeti/HTools \
76         test/hs/Test/Ganeti/HTools/Backend \
77         test/hs/Test/Ganeti/Query
78
79 DIRS = \
80         $(HS_DIRS) \
81         autotools \
82         daemons \
83         devel \
84         doc \
85         doc/css \
86         doc/examples \
87         doc/examples/gnt-debug \
88         doc/examples/hooks \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/hs/shelltests \
92         lib \
93         lib/build \
94         lib/client \
95         lib/confd \
96         lib/http \
97         lib/hypervisor \
98         lib/impexpd \
99         lib/masterd \
100         lib/rapi \
101         lib/server \
102         lib/tools \
103         lib/utils \
104         lib/watcher \
105         man \
106         qa \
107         test \
108         test/data \
109         test/data/ovfdata \
110         test/data/ovfdata/other \
111         test/py \
112         tools
113
114 ALL_APIDOC_HS_DIRS = \
115         $(APIDOC_HS_DIR) \
116         $(APIDOC_HS_DIR)/Ganeti \
117         $(APIDOC_HS_DIR)/Ganeti/Block \
118         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
119         $(APIDOC_HS_DIR)/Ganeti/Confd \
120         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
121         $(APIDOC_HS_DIR)/Ganeti/HTools \
122         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
123         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
124         $(APIDOC_HS_DIR)/Ganeti/Query
125
126 BUILDTIME_DIR_AUTOCREATE = \
127         scripts \
128         $(APIDOC_DIR) \
129         $(ALL_APIDOC_HS_DIRS) \
130         $(APIDOC_PY_DIR) \
131         $(COVERAGE_DIR) \
132         $(COVERAGE_HS_DIR) \
133         $(COVERAGE_PY_DIR) \
134         .hpc
135
136 BUILDTIME_DIRS = \
137         $(BUILDTIME_DIR_AUTOCREATE) \
138         doc/html \
139         doc/man-html
140
141 DIRCHECK_EXCLUDE = \
142         $(BUILDTIME_DIRS) \
143         ganeti-[0-9]*.[0-9]*.[0-9]* \
144         doc/html/_* \
145         doc/man-html/_* \
146         autom4te.cache
147
148 # some helper vars
149 COVERAGE_DIR = doc/coverage
150 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
151 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
152 APIDOC_DIR = doc/api
153 APIDOC_PY_DIR = $(APIDOC_DIR)/py
154 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
155
156 MAINTAINERCLEANFILES = \
157         $(maninput) \
158         doc/install-quick.rst \
159         doc/news.rst \
160         doc/upgrade.rst \
161         vcs-version
162
163 maintainer-clean-local:
164         rm -rf $(BUILDTIME_DIRS)
165
166 CLEANFILES = \
167         $(addsuffix /*.py[co],$(DIRS)) \
168         $(addsuffix /*.hi,$(HS_DIRS)) \
169         $(addsuffix /*.o,$(HS_DIRS)) \
170         $(PYTHON_BOOTSTRAP) \
171         epydoc.conf \
172         $(REPLACE_VARS_SED) \
173         $(SHELL_ENV_INIT) \
174         daemons/daemon-util \
175         daemons/ganeti-cleaner \
176         $(mandocrst) \
177         doc/manpages-enabled.rst \
178         $(BUILT_EXAMPLES) \
179         doc/examples/bash_completion \
180         doc/examples/bash_completion-debug \
181         lib/_generated_rpc.py \
182         $(man_MANS) \
183         $(manhtml) \
184         tools/kvm-ifup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/objectutils.py \
264         lib/opcodes.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/burnin.py \
344         lib/tools/ensure_dirs.py \
345         lib/tools/node_cleanup.py \
346         lib/tools/node_daemon_setup.py \
347         lib/tools/prepare_node_join.py
348
349 utils_PYTHON = \
350         lib/utils/__init__.py \
351         lib/utils/algo.py \
352         lib/utils/filelock.py \
353         lib/utils/hash.py \
354         lib/utils/io.py \
355         lib/utils/log.py \
356         lib/utils/lvm.py \
357         lib/utils/mlock.py \
358         lib/utils/nodesetup.py \
359         lib/utils/process.py \
360         lib/utils/retry.py \
361         lib/utils/text.py \
362         lib/utils/wrapper.py \
363         lib/utils/x509.py
364
365 docinput = \
366         doc/conf.py \
367         doc/css/style.css \
368         doc/admin.rst \
369         doc/cluster-merge.rst \
370         doc/design-2.0.rst \
371         doc/design-2.1.rst \
372         doc/design-2.2.rst \
373         doc/design-2.3.rst \
374         doc/design-2.4.rst \
375         doc/design-2.5.rst \
376         doc/design-2.6.rst \
377         doc/design-2.7.rst \
378         doc/design-autorepair.rst \
379         doc/design-bulk-create.rst \
380         doc/design-chained-jobs.rst \
381         doc/design-cpu-pinning.rst \
382         doc/design-draft.rst \
383         doc/design-htools-2.3.rst \
384         doc/design-http-server.rst \
385         doc/design-impexp2.rst \
386         doc/design-lu-generated-jobs.rst \
387         doc/design-linuxha.rst \
388         doc/design-multi-reloc.rst \
389         doc/design-network.rst \
390         doc/design-node-add.rst \
391         doc/design-oob.rst \
392         doc/design-ovf-support.rst \
393         doc/design-opportunistic-locking.rst \
394         doc/design-partitioned.rst \
395         doc/design-query-splitting.rst \
396         doc/design-query2.rst \
397         doc/design-remote-commands.rst \
398         doc/design-resource-model.rst \
399         doc/design-shared-storage.rst \
400         doc/design-monitoring-agent.rst \
401         doc/design-virtual-clusters.rst \
402         doc/design-x509-ca.rst \
403         doc/devnotes.rst \
404         doc/glossary.rst \
405         doc/hooks.rst \
406         doc/iallocator.rst \
407         doc/index.rst \
408         doc/install-quick.rst \
409         doc/install.rst \
410         doc/locking.rst \
411         doc/manpages-disabled.rst \
412         doc/move-instance.rst \
413         doc/news.rst \
414         doc/ovfconverter.rst \
415         doc/rapi.rst \
416         doc/security.rst \
417         doc/upgrade.rst \
418         doc/virtual-cluster.rst \
419         doc/walkthrough.rst
420
421 # Generates file names such as "doc/man-gnt-instance.rst"
422 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
423
424 # Haskell programs to be installed in $PREFIX/bin
425 HS_BIN_PROGS=src/htools
426
427 # Haskell programs to be installed in the MYEXECLIB dir
428 HS_MYEXECLIB_PROGS=src/mon-collector
429
430 # Haskell programs to compiled but not installed automatically
431 # Usually they have their own specific installation rules
432 HS_COMPILE_PROGS= \
433         src/hconfd \
434         src/rpc-test
435
436 # All Haskell non-test programs to be compiled but not automatically installed
437 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
438
439 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
440 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
441
442 HS_ALL_PROGS = \
443         $(HS_PROGS) \
444         test/hs/hpc-htools \
445         test/hs/hpc-mon-collector \
446         test/hs/htest \
447         $(HS_COMPILE_PROGS)
448
449 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
450 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
451
452 HFLAGS = \
453         -O -Wall -Werror -isrc \
454         -fwarn-monomorphism-restriction \
455         -fwarn-tabs \
456         $(GHC_BYVERSION_FLAGS)
457
458 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
459 HEXTRA =
460 # internal extra flags (used for test/hs/htest mainly)
461 HEXTRA_INT =
462 # exclude options for coverage reports
463 HPCEXCL = --exclude Main \
464         --exclude Ganeti.Constants \
465         --exclude Ganeti.HTools.QC \
466         --exclude Ganeti.THH \
467         --exclude Ganeti.Version \
468         --exclude Test.Ganeti.Attoparsec \
469         --exclude Test.Ganeti.TestCommon \
470         --exclude Test.Ganeti.TestHTools \
471         --exclude Test.Ganeti.TestHelper \
472         --exclude Test.Ganeti.TestImports \
473         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
474
475 HS_LIB_SRCS = \
476         src/Ganeti/Block/Drbd/Types.hs \
477         src/Ganeti/Block/Drbd/Parser.hs \
478         src/Ganeti/BasicTypes.hs \
479         src/Ganeti/Common.hs \
480         src/Ganeti/Compat.hs \
481         src/Ganeti/Confd/Client.hs \
482         src/Ganeti/Confd/Server.hs \
483         src/Ganeti/Confd/Types.hs \
484         src/Ganeti/Confd/Utils.hs \
485         src/Ganeti/Config.hs \
486         src/Ganeti/Daemon.hs \
487         src/Ganeti/DataCollectors/CLI.hs \
488         src/Ganeti/DataCollectors/Drbd.hs \
489         src/Ganeti/DataCollectors/Program.hs \
490         src/Ganeti/DataCollectors/Types.hs \
491         src/Ganeti/Errors.hs \
492         src/Ganeti/HTools/Backend/IAlloc.hs \
493         src/Ganeti/HTools/Backend/Luxi.hs \
494         src/Ganeti/HTools/Backend/Rapi.hs \
495         src/Ganeti/HTools/Backend/Simu.hs \
496         src/Ganeti/HTools/Backend/Text.hs \
497         src/Ganeti/HTools/CLI.hs \
498         src/Ganeti/HTools/Cluster.hs \
499         src/Ganeti/HTools/Container.hs \
500         src/Ganeti/HTools/ExtLoader.hs \
501         src/Ganeti/HTools/Graph.hs \
502         src/Ganeti/HTools/Group.hs \
503         src/Ganeti/HTools/Instance.hs \
504         src/Ganeti/HTools/Loader.hs \
505         src/Ganeti/HTools/Node.hs \
506         src/Ganeti/HTools/PeerMap.hs \
507         src/Ganeti/HTools/Program/Hail.hs \
508         src/Ganeti/HTools/Program/Hbal.hs \
509         src/Ganeti/HTools/Program/Hcheck.hs \
510         src/Ganeti/HTools/Program/Hinfo.hs \
511         src/Ganeti/HTools/Program/Hscan.hs \
512         src/Ganeti/HTools/Program/Hspace.hs \
513         src/Ganeti/HTools/Program/Hroller.hs \
514         src/Ganeti/HTools/Program/Main.hs \
515         src/Ganeti/HTools/Types.hs \
516         src/Ganeti/Hash.hs \
517         src/Ganeti/JQueue.hs \
518         src/Ganeti/JSON.hs \
519         src/Ganeti/Jobs.hs \
520         src/Ganeti/Logging.hs \
521         src/Ganeti/Luxi.hs \
522         src/Ganeti/Network.hs \
523         src/Ganeti/Objects.hs \
524         src/Ganeti/OpCodes.hs \
525         src/Ganeti/OpParams.hs \
526         src/Ganeti/Path.hs \
527         src/Ganeti/Query/Common.hs \
528         src/Ganeti/Query/Filter.hs \
529         src/Ganeti/Query/Group.hs \
530         src/Ganeti/Query/Job.hs \
531         src/Ganeti/Query/Language.hs \
532         src/Ganeti/Query/Node.hs \
533         src/Ganeti/Query/Query.hs \
534         src/Ganeti/Query/Server.hs \
535         src/Ganeti/Query/Types.hs \
536         src/Ganeti/Rpc.hs \
537         src/Ganeti/Runtime.hs \
538         src/Ganeti/Ssconf.hs \
539         src/Ganeti/THH.hs \
540         src/Ganeti/Types.hs \
541         src/Ganeti/Utils.hs
542
543 HS_TEST_SRCS = \
544         test/hs/Test/Ganeti/Attoparsec.hs \
545         test/hs/Test/Ganeti/BasicTypes.hs \
546         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
547         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
548         test/hs/Test/Ganeti/Common.hs \
549         test/hs/Test/Ganeti/Confd/Types.hs \
550         test/hs/Test/Ganeti/Confd/Utils.hs \
551         test/hs/Test/Ganeti/Daemon.hs \
552         test/hs/Test/Ganeti/Errors.hs \
553         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
554         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
555         test/hs/Test/Ganeti/HTools/CLI.hs \
556         test/hs/Test/Ganeti/HTools/Cluster.hs \
557         test/hs/Test/Ganeti/HTools/Container.hs \
558         test/hs/Test/Ganeti/HTools/Graph.hs \
559         test/hs/Test/Ganeti/HTools/Instance.hs \
560         test/hs/Test/Ganeti/HTools/Loader.hs \
561         test/hs/Test/Ganeti/HTools/Node.hs \
562         test/hs/Test/Ganeti/HTools/PeerMap.hs \
563         test/hs/Test/Ganeti/HTools/Types.hs \
564         test/hs/Test/Ganeti/JSON.hs \
565         test/hs/Test/Ganeti/Jobs.hs \
566         test/hs/Test/Ganeti/JQueue.hs \
567         test/hs/Test/Ganeti/Luxi.hs \
568         test/hs/Test/Ganeti/Network.hs \
569         test/hs/Test/Ganeti/Objects.hs \
570         test/hs/Test/Ganeti/OpCodes.hs \
571         test/hs/Test/Ganeti/Query/Filter.hs \
572         test/hs/Test/Ganeti/Query/Language.hs \
573         test/hs/Test/Ganeti/Query/Query.hs \
574         test/hs/Test/Ganeti/Rpc.hs \
575         test/hs/Test/Ganeti/Ssconf.hs \
576         test/hs/Test/Ganeti/THH.hs \
577         test/hs/Test/Ganeti/TestCommon.hs \
578         test/hs/Test/Ganeti/TestHTools.hs \
579         test/hs/Test/Ganeti/TestHelper.hs \
580         test/hs/Test/Ganeti/Types.hs \
581         test/hs/Test/Ganeti/Utils.hs
582
583 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
584
585 HS_BUILT_SRCS = \
586         test/hs/Test/Ganeti/TestImports.hs \
587         src/Ganeti/Constants.hs \
588         src/Ganeti/Version.hs
589 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
590
591 $(RUN_IN_TEMPDIR): | stamp-directories
592
593 doc/html/index.html: ENABLE_MANPAGES =
594 doc/man-html/index.html: ENABLE_MANPAGES = 1
595 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
596
597 # Note: we use here an order-only prerequisite, as the contents of
598 # _autoconf.py are not actually influencing the html build output: it
599 # has to exist in order for the sphinx module to be loaded
600 # successfully, but we certainly don't want the docs to be rebuilt if
601 # it changes
602 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
603         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
604         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
605         doc/css/style.css \
606         | $(BUILT_PYTHON_SOURCES)
607         @test -n "$(SPHINX)" || \
608             { echo 'sphinx-build' not found during configure; exit 1; }
609 if !MANPAGES_IN_DOC
610         if test -n '$(ENABLE_MANPAGES)'; then \
611           echo 'Man pages in documentation were disabled at configure time' >&2; \
612           exit 1; \
613         fi
614 endif
615 ## Sphinx provides little control over what content should be included. Some
616 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
617 ## build two different versions of the documentation--once without man pages and
618 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
619 ## us with this, but requires running in a temporary directory. It moves the
620 ## correct files into place depending on environment variables.
621         dir=$(dir $@) && \
622         @mkdir_p@ $$dir && \
623         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
624         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
625             -d . \
626             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
627             -D release="$(PACKAGE_VERSION)" \
628             -D graphviz_dot="$(DOT)" \
629             -D enable_manpages="$(ENABLE_MANPAGES)" \
630             doc $(CURDIR)/$$dir && \
631         rm -f $$dir/.buildinfo $$dir/objects.inv
632         touch $@
633
634 doc/html: doc/html/index.html
635
636 doc/man-html: doc/man-html/index.html
637
638 doc/install-quick.rst: INSTALL
639 doc/news.rst: NEWS
640 doc/upgrade.rst: UPGRADE
641
642 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
643         set -e; \
644         { echo '.. This file is automatically updated at build time from $<.'; \
645           echo '.. Do not edit.'; \
646           echo; \
647           cat $<; \
648         } > $@
649
650 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
651         { echo '.. This file is automatically generated, do not edit!'; \
652           echo ''; \
653           echo 'Man pages'; \
654           echo '========='; \
655           echo; \
656           echo '.. toctree::'; \
657           echo '   :maxdepth: 1'; \
658           echo; \
659           for i in $(notdir $(mandocrst)); do \
660             echo "   $$i"; \
661           done | LC_ALL=C sort; \
662         } > $@
663
664 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
665 if MANPAGES_IN_DOC
666         { echo '.. This file is automatically updated at build time from $<.'; \
667           echo '.. Do not edit.'; \
668           echo; \
669           echo "$*"; \
670           echo '=========================================='; \
671           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
672         } > $@
673 else
674         echo 'Man pages in documentation were disabled at configure time' >&2; \
675         exit 1;
676 endif
677
678 # Things to build but not to install (add it to EXTRA_DIST if it should be
679 # distributed)
680 noinst_DATA = \
681         doc/html \
682         $(BUILT_EXAMPLES) \
683         doc/examples/bash_completion \
684         doc/examples/bash_completion-debug \
685         $(manhtml)
686
687 if MANPAGES_IN_DOC
688 noinst_DATA += doc/man-html
689 endif
690
691 gnt_scripts = \
692         scripts/gnt-backup \
693         scripts/gnt-cluster \
694         scripts/gnt-debug \
695         scripts/gnt-group \
696         scripts/gnt-instance \
697         scripts/gnt-job \
698         scripts/gnt-network \
699         scripts/gnt-node \
700         scripts/gnt-os \
701         scripts/gnt-storage
702
703 PYTHON_BOOTSTRAP_SBIN = \
704         daemons/ganeti-masterd \
705         daemons/ganeti-noded \
706         daemons/ganeti-rapi \
707         daemons/ganeti-watcher \
708         $(gnt_scripts)
709
710 PYTHON_BOOTSTRAP = \
711         $(PYTHON_BOOTSTRAP_SBIN) \
712         tools/burnin \
713         tools/ensure-dirs \
714         tools/node-cleanup \
715         tools/node-daemon-setup \
716         tools/prepare-node-join
717
718 qa_scripts = \
719         qa/__init__.py \
720         qa/ganeti-qa.py \
721         qa/qa_cluster.py \
722         qa/qa_config.py \
723         qa/qa_daemon.py \
724         qa/qa_env.py \
725         qa/qa_error.py \
726         qa/qa_group.py \
727         qa/qa_instance.py \
728         qa/qa_job.py \
729         qa/qa_node.py \
730         qa/qa_os.py \
731         qa/qa_rapi.py \
732         qa/qa_tags.py \
733         qa/qa_utils.py
734
735 bin_SCRIPTS =
736 if WANT_HTOOLS
737 bin_SCRIPTS += $(HS_BIN_PROGS)
738 install-exec-hook:
739         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
740 # FIXME: this is a hardcoded logic, instead of auto-resolving
741         $(LN_S) -f ../../../bin/htools \
742           $(DESTDIR)$(iallocatorsdir)/hail
743         for role in $(HS_BIN_ROLES); do \
744           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
745         done
746 endif
747
748 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
749         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
750           echo "Error: cannot run unittests without the development" \
751                " libraries (see devnotes.rst)" 1>&2; \
752           exit 1; \
753         fi
754         @rm -f $(notdir $@).tix
755         $(GHC) --make \
756           $(HFLAGS) \
757           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
758           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
759           $(HEXTRA) $(HEXTRA_INT) $@
760         @touch "$@"
761
762 # for the test/hs/htest binary, we need to enable profiling/coverage
763 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
764
765 # we compile the hpc-htools binary with the program coverage
766 test/hs/hpc-htools: HEXTRA_INT=-fhpc
767
768 # we compile the hpc-mon-collector binary with the program coverage
769 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
770
771 # test dependency
772 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
773
774 # rules for building profiling-enabled versions of the haskell
775 # programs: hs-prof does the full two-step build, whereas
776 # hs-prof-quick does only the final rebuild (hs-prof must have been
777 # run before)
778 .PHONY: hs-prof hs-prof-quick
779 hs-prof:
780         @if [ -z "$(TARGET)" ]; then \
781           echo "You need to define TARGET when running this rule" 1>&2; \
782           exit 1; \
783         fi
784         $(MAKE) $(AM_MAKEFLAGS) clean
785         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
786         rm -f $(HS_ALL_PROGS)
787         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
788
789 hs-prof-quick:
790         @if [ -z "$(TARGET)" ]; then \
791           echo "You need to define TARGET when running this rule" 1>&2; \
792           exit 1; \
793         fi
794         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
795
796 dist_sbin_SCRIPTS = \
797         tools/ganeti-listrunner
798
799 nodist_sbin_SCRIPTS = \
800         $(PYTHON_BOOTSTRAP_SBIN) \
801         daemons/ganeti-cleaner
802
803 if ENABLE_CONFD
804 src/ganeti-confd: src/hconfd
805         cp -f $< $@
806
807 nodist_sbin_SCRIPTS += src/ganeti-confd
808 endif
809
810 python_scripts = \
811         tools/cfgshell \
812         tools/cfgupgrade \
813         tools/cfgupgrade12 \
814         tools/cluster-merge \
815         tools/confd-client \
816         tools/fmtjson \
817         tools/lvmstrap \
818         tools/move-instance \
819         tools/ovfconverter \
820         tools/sanitize-config
821
822 dist_tools_SCRIPTS = \
823         $(python_scripts) \
824         tools/kvm-console-wrapper \
825         tools/master-ip-setup \
826         tools/xen-console-wrapper
827
828 nodist_tools_python_scripts = \
829         tools/node-cleanup
830
831 nodist_tools_SCRIPTS = \
832         $(nodist_tools_python_scripts) \
833         tools/vcluster-setup
834
835 pkglib_python_scripts = \
836         daemons/import-export \
837         tools/check-cert-expired
838
839 nodist_pkglib_python_scripts = \
840         tools/burnin \
841         tools/ensure-dirs \
842         tools/node-daemon-setup \
843         tools/prepare-node-join
844
845 myexeclib_SCRIPTS = \
846         daemons/daemon-util \
847         tools/kvm-ifup \
848         $(pkglib_python_scripts) \
849         $(HS_MYEXECLIB_PROGS)
850
851 nodist_myexeclib_SCRIPTS = \
852         $(nodist_pkglib_python_scripts)
853
854 EXTRA_DIST = \
855         NEWS \
856         UPGRADE \
857         epydoc.conf.in \
858         pylintrc \
859         autotools/build-bash-completion \
860         autotools/build-rpc \
861         autotools/check-header \
862         autotools/check-imports \
863         autotools/check-man-dashes \
864         autotools/check-man-references \
865         autotools/check-man-warnings \
866         autotools/check-news \
867         autotools/check-python-code \
868         autotools/check-tar \
869         autotools/check-version \
870         autotools/convert-constants \
871         autotools/docpp \
872         autotools/gen-py-coverage \
873         autotools/sphinx-wrapper \
874         autotools/testrunner \
875         autotools/wrong-hardcoded-paths \
876         $(RUN_IN_TEMPDIR) \
877         daemons/daemon-util.in \
878         daemons/ganeti-cleaner.in \
879         $(pkglib_python_scripts) \
880         devel/upload \
881         devel/webserver \
882         tools/kvm-ifup.in \
883         tools/vcluster-setup.in \
884         $(docinput) \
885         doc/html \
886         $(BUILT_EXAMPLES:%=%.in) \
887         doc/examples/ganeti.default \
888         doc/examples/ganeti.default-debug \
889         doc/examples/hooks/ethers \
890         doc/examples/gnt-debug/README \
891         doc/examples/gnt-debug/delay0.json \
892         doc/examples/gnt-debug/delay50.json \
893         test/py/lockperf.py \
894         test/py/testutils.py \
895         test/py/mocks.py \
896         $(dist_TESTS) \
897         $(TEST_FILES) \
898         man/footer.rst \
899         $(manrst) \
900         $(maninput) \
901         qa/qa-sample.json \
902         $(qa_scripts) \
903         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
904         $(HS_PROG_SRCS) \
905         src/lint-hints.hs \
906         test/hs/cli-tests-defs.sh \
907         test/hs/offline-test.sh \
908         .ghci
909
910 man_MANS = \
911         man/ganeti-cleaner.8 \
912         man/ganeti-confd.8 \
913         man/ganeti-listrunner.8 \
914         man/ganeti-masterd.8 \
915         man/ganeti-noded.8 \
916         man/ganeti-os-interface.7 \
917         man/ganeti-extstorage-interface.7 \
918         man/ganeti-rapi.8 \
919         man/ganeti-watcher.8 \
920         man/ganeti.7 \
921         man/gnt-backup.8 \
922         man/gnt-cluster.8 \
923         man/gnt-debug.8 \
924         man/gnt-group.8 \
925         man/gnt-network.8 \
926         man/gnt-instance.8 \
927         man/gnt-job.8 \
928         man/gnt-node.8 \
929         man/gnt-os.8 \
930         man/gnt-storage.8 \
931         man/hail.1 \
932         man/hbal.1 \
933         man/hcheck.1 \
934         man/hinfo.1 \
935         man/hscan.1 \
936         man/hspace.1 \
937         man/hroller.1 \
938         man/htools.1 \
939         man/mon-collector.7
940
941 # Remove extensions from all filenames in man_MANS
942 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
943
944 manrst = $(patsubst %,%.rst,$(mannoext))
945 manhtml = $(patsubst %.rst,%.html,$(manrst))
946 mangen = $(patsubst %.rst,%.gen,$(manrst))
947 maninput = \
948         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
949         $(patsubst %.html,%.html.in,$(manhtml)) \
950         $(mangen)
951
952 TEST_FILES = \
953         test/data/htools/clean-nonzero-score.data \
954         test/data/htools/common-suffix.data \
955         test/data/htools/empty-cluster.data \
956         test/data/htools/hail-alloc-drbd.json \
957         test/data/htools/hail-change-group.json \
958         test/data/htools/hail-invalid-reloc.json \
959         test/data/htools/hail-node-evac.json \
960         test/data/htools/hail-reloc-drbd.json \
961         test/data/htools/hbal-excl-tags.data \
962         test/data/htools/hbal-split-insts.data \
963         test/data/htools/invalid-node.data \
964         test/data/htools/missing-resources.data \
965         test/data/htools/n1-failure.data \
966         test/data/htools/rapi/groups.json \
967         test/data/htools/rapi/info.json \
968         test/data/htools/rapi/instances.json \
969         test/data/htools/rapi/nodes.json \
970         test/hs/shelltests/htools-balancing.test \
971         test/hs/shelltests/htools-basic.test \
972         test/hs/shelltests/htools-dynutil.test \
973         test/hs/shelltests/htools-excl.test \
974         test/hs/shelltests/htools-hail.test \
975         test/hs/shelltests/htools-hspace.test \
976         test/hs/shelltests/htools-invalid.test \
977         test/hs/shelltests/htools-multi-group.test \
978         test/hs/shelltests/htools-no-backend.test \
979         test/hs/shelltests/htools-rapi.test \
980         test/hs/shelltests/htools-single-group.test \
981         test/hs/shelltests/htools-text-backend.test \
982         test/hs/shelltests/htools-mon-collector.test \
983         test/data/bdev-drbd-8.0.txt \
984         test/data/bdev-drbd-8.3.txt \
985         test/data/bdev-drbd-disk.txt \
986         test/data/bdev-drbd-net-ip4.txt \
987         test/data/bdev-drbd-net-ip6.txt \
988         test/data/cert1.pem \
989         test/data/cert2.pem \
990         test/data/instance-minor-pairing.txt \
991         test/data/ip-addr-show-dummy0.txt \
992         test/data/ip-addr-show-lo-ipv4.txt \
993         test/data/ip-addr-show-lo-ipv6.txt \
994         test/data/ip-addr-show-lo-oneline-ipv4.txt \
995         test/data/ip-addr-show-lo-oneline-ipv6.txt \
996         test/data/ip-addr-show-lo-oneline.txt \
997         test/data/ip-addr-show-lo.txt \
998         test/data/kvm_0.12.5_help.txt \
999         test/data/kvm_0.15.90_help.txt \
1000         test/data/kvm_0.9.1_help.txt \
1001         test/data/kvm_0.9.1_help_boot_test.txt \
1002         test/data/kvm_1.0_help.txt \
1003         test/data/kvm_1.1.2_help.txt \
1004         test/data/ovfdata/compr_disk.vmdk.gz \
1005         test/data/ovfdata/config.ini \
1006         test/data/ovfdata/corrupted_resources.ovf \
1007         test/data/ovfdata/empty.ini \
1008         test/data/ovfdata/empty.ovf \
1009         test/data/ovfdata/ganeti.mf \
1010         test/data/ovfdata/ganeti.ovf \
1011         test/data/ovfdata/gzip_disk.ovf \
1012         test/data/ovfdata/new_disk.vmdk \
1013         test/data/ovfdata/no_disk.ini \
1014         test/data/ovfdata/no_disk_in_ref.ovf \
1015         test/data/ovfdata/no_os.ini \
1016         test/data/ovfdata/no_ovf.ova \
1017         test/data/ovfdata/other/rawdisk.raw \
1018         test/data/ovfdata/ova.ova \
1019         test/data/ovfdata/rawdisk.raw \
1020         test/data/ovfdata/second_disk.vmdk \
1021         test/data/ovfdata/unsafe_path.ini \
1022         test/data/ovfdata/virtualbox.ovf \
1023         test/data/ovfdata/wrong_config.ini \
1024         test/data/ovfdata/wrong_extension.ovd \
1025         test/data/ovfdata/wrong_manifest.mf \
1026         test/data/ovfdata/wrong_manifest.ovf \
1027         test/data/ovfdata/wrong_ova.ova \
1028         test/data/ovfdata/wrong_xml.ovf \
1029         test/data/proc_drbd8.txt \
1030         test/data/proc_drbd80-emptyline.txt \
1031         test/data/proc_drbd83.txt \
1032         test/data/proc_drbd83_sync.txt \
1033         test/data/proc_drbd83_sync_want.txt \
1034         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1035         test/data/sys_drbd_usermode_helper.txt \
1036         test/data/vgreduce-removemissing-2.02.02.txt \
1037         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1038         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1039         test/data/vgs-missing-pvs-2.02.02.txt \
1040         test/data/vgs-missing-pvs-2.02.66.txt \
1041         test/py/ganeti-cli.test \
1042         test/py/gnt-cli.test \
1043         test/py/import-export_unittest-helper
1044
1045 python_tests = \
1046         doc/examples/rapi_testutils.py \
1047         test/py/cfgupgrade_unittest.py \
1048         test/py/docs_unittest.py \
1049         test/py/ganeti.asyncnotifier_unittest.py \
1050         test/py/ganeti.backend_unittest-runasroot.py \
1051         test/py/ganeti.backend_unittest.py \
1052         test/py/ganeti.bdev_unittest.py \
1053         test/py/ganeti.cli_unittest.py \
1054         test/py/ganeti.client.gnt_cluster_unittest.py \
1055         test/py/ganeti.client.gnt_instance_unittest.py \
1056         test/py/ganeti.client.gnt_job_unittest.py \
1057         test/py/ganeti.cmdlib_unittest.py \
1058         test/py/ganeti.compat_unittest.py \
1059         test/py/ganeti.confd.client_unittest.py \
1060         test/py/ganeti.config_unittest.py \
1061         test/py/ganeti.constants_unittest.py \
1062         test/py/ganeti.daemon_unittest.py \
1063         test/py/ganeti.errors_unittest.py \
1064         test/py/ganeti.hooks_unittest.py \
1065         test/py/ganeti.ht_unittest.py \
1066         test/py/ganeti.http_unittest.py \
1067         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1068         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1069         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1070         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1071         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1072         test/py/ganeti.hypervisor_unittest.py \
1073         test/py/ganeti.impexpd_unittest.py \
1074         test/py/ganeti.jqueue_unittest.py \
1075         test/py/ganeti.jstore_unittest.py \
1076         test/py/ganeti.locking_unittest.py \
1077         test/py/ganeti.luxi_unittest.py \
1078         test/py/ganeti.masterd.iallocator_unittest.py \
1079         test/py/ganeti.masterd.instance_unittest.py \
1080         test/py/ganeti.mcpu_unittest.py \
1081         test/py/ganeti.netutils_unittest.py \
1082         test/py/ganeti.objects_unittest.py \
1083         test/py/ganeti.objectutils_unittest.py \
1084         test/py/ganeti.opcodes_unittest.py \
1085         test/py/ganeti.ovf_unittest.py \
1086         test/py/ganeti.qlang_unittest.py \
1087         test/py/ganeti.query_unittest.py \
1088         test/py/ganeti.rapi.baserlib_unittest.py \
1089         test/py/ganeti.rapi.client_unittest.py \
1090         test/py/ganeti.rapi.resources_unittest.py \
1091         test/py/ganeti.rapi.rlib2_unittest.py \
1092         test/py/ganeti.rapi.testutils_unittest.py \
1093         test/py/ganeti.rpc_unittest.py \
1094         test/py/ganeti.runtime_unittest.py \
1095         test/py/ganeti.serializer_unittest.py \
1096         test/py/ganeti.server.rapi_unittest.py \
1097         test/py/ganeti.ssconf_unittest.py \
1098         test/py/ganeti.ssh_unittest.py \
1099         test/py/ganeti.storage_unittest.py \
1100         test/py/ganeti.tools.burnin_unittest.py \
1101         test/py/ganeti.tools.ensure_dirs_unittest.py \
1102         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1103         test/py/ganeti.tools.prepare_node_join_unittest.py \
1104         test/py/ganeti.uidpool_unittest.py \
1105         test/py/ganeti.utils.algo_unittest.py \
1106         test/py/ganeti.utils.filelock_unittest.py \
1107         test/py/ganeti.utils.hash_unittest.py \
1108         test/py/ganeti.utils.io_unittest-runasroot.py \
1109         test/py/ganeti.utils.io_unittest.py \
1110         test/py/ganeti.utils.log_unittest.py \
1111         test/py/ganeti.utils.lvm_unittest.py \
1112         test/py/ganeti.utils.mlock_unittest.py \
1113         test/py/ganeti.utils.nodesetup_unittest.py \
1114         test/py/ganeti.utils.process_unittest.py \
1115         test/py/ganeti.utils.retry_unittest.py \
1116         test/py/ganeti.utils.text_unittest.py \
1117         test/py/ganeti.utils.wrapper_unittest.py \
1118         test/py/ganeti.utils.x509_unittest.py \
1119         test/py/ganeti.utils_unittest.py \
1120         test/py/ganeti.vcluster_unittest.py \
1121         test/py/ganeti.workerpool_unittest.py \
1122         test/py/pycurl_reset_unittest.py \
1123         test/py/qa.qa_config_unittest.py \
1124         test/py/tempfile_fork_unittest.py
1125
1126 haskell_tests = test/hs/htest
1127
1128 dist_TESTS = \
1129         test/py/check-cert-expired_unittest.bash \
1130         test/py/daemon-util_unittest.bash \
1131         test/py/ganeti-cleaner_unittest.bash \
1132         test/py/import-export_unittest.bash \
1133         test/py/cli-test.bash \
1134         test/py/bash_completion.bash \
1135         $(python_tests)
1136
1137 nodist_TESTS =
1138 check_SCRIPTS =
1139
1140 if WANT_HSTESTS
1141 nodist_TESTS += $(haskell_tests)
1142 dist_TESTS += test/hs/offline-test.sh
1143 check_SCRIPTS += \
1144         test/hs/hpc-htools \
1145         test/hs/hpc-mon-collector \
1146         $(HS_BUILT_TEST_HELPERS)
1147 endif
1148
1149 TESTS = $(dist_TESTS) $(nodist_TESTS)
1150
1151 # Environment for all tests
1152 PLAIN_TESTS_ENVIRONMENT = \
1153         PYTHONPATH=. \
1154         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1155         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1156         $(RUN_IN_TEMPDIR)
1157
1158 # Environment for tests run by automake
1159 TESTS_ENVIRONMENT = \
1160         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1161
1162 all_python_code = \
1163         $(dist_sbin_SCRIPTS) \
1164         $(python_scripts) \
1165         $(pkglib_python_scripts) \
1166         $(nodist_pkglib_python_scripts) \
1167         $(nodist_tools_python_scripts) \
1168         $(python_tests) \
1169         $(pkgpython_PYTHON) \
1170         $(client_PYTHON) \
1171         $(hypervisor_PYTHON) \
1172         $(rapi_PYTHON) \
1173         $(server_PYTHON) \
1174         $(pytools_PYTHON) \
1175         $(http_PYTHON) \
1176         $(confd_PYTHON) \
1177         $(masterd_PYTHON) \
1178         $(impexpd_PYTHON) \
1179         $(utils_PYTHON) \
1180         $(watcher_PYTHON) \
1181         $(noinst_PYTHON) \
1182         $(qa_scripts)
1183
1184 srclink_files = \
1185         man/footer.rst \
1186         test/py/check-cert-expired_unittest.bash \
1187         test/py/daemon-util_unittest.bash \
1188         test/py/ganeti-cleaner_unittest.bash \
1189         test/py/import-export_unittest.bash \
1190         test/py/cli-test.bash \
1191         test/py/bash_completion.bash \
1192         test/hs/offline-test.sh \
1193         test/hs/cli-tests-defs.sh \
1194         $(all_python_code) \
1195         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1196         $(docinput)
1197
1198 check_python_code = \
1199         $(BUILD_BASH_COMPLETION) \
1200         $(CHECK_IMPORTS) \
1201         $(CHECK_HEADER) \
1202         $(DOCPP) \
1203         $(all_python_code)
1204
1205 lint_python_code = \
1206         ganeti \
1207         ganeti/http/server.py \
1208         $(dist_sbin_SCRIPTS) \
1209         $(python_scripts) \
1210         $(pkglib_python_scripts) \
1211         $(BUILD_BASH_COMPLETION) \
1212         $(CHECK_IMPORTS) \
1213         $(CHECK_HEADER) \
1214         $(DOCPP) \
1215         $(PYTHON_BOOTSTRAP)
1216
1217 standalone_python_modules = \
1218         lib/rapi/client.py \
1219         tools/ganeti-listrunner
1220
1221 pep8_python_code = \
1222         ganeti \
1223         ganeti/http/server.py \
1224         $(dist_sbin_SCRIPTS) \
1225         $(python_scripts) \
1226         $(pkglib_python_scripts) \
1227         $(BUILD_BASH_COMPLETION) \
1228         $(CHECK_HEADER) \
1229         $(DOCPP) \
1230         $(PYTHON_BOOTSTRAP) \
1231         qa
1232
1233 test/py/daemon-util_unittest.bash: daemons/daemon-util
1234
1235 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1236
1237 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1238
1239 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1240         sed -f $(REPLACE_VARS_SED) < $< > $@
1241         chmod +x $@
1242
1243 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1244         sed -f $(REPLACE_VARS_SED) < $< > $@
1245         chmod +x $@
1246
1247 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1248         sed -f $(REPLACE_VARS_SED) < $< > $@
1249         chmod +x $@
1250
1251 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1252         sed -f $(REPLACE_VARS_SED) < $< > $@
1253
1254 doc/examples/bash_completion: BC_ARGS = --compact
1255 doc/examples/bash_completion-debug: BC_ARGS =
1256
1257 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1258         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1259         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1260         daemons/ganeti-cleaner \
1261         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1262         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1263           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1264
1265 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1266         lib/build/shell_example_lexer.py \
1267         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1268         @echo "Checking $< for hardcoded paths..."
1269         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1270           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1271           exit 1; \
1272         fi
1273         set -e ; \
1274         trap 'echo auto-removing $@; rm $@' EXIT; \
1275         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1276         $(CHECK_MAN_REFERENCES) $@; \
1277         trap - EXIT
1278
1279 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1280         @test -n "$(PANDOC)" || \
1281           { echo 'pandoc' not found during configure; exit 1; }
1282         set -o pipefail ; \
1283         trap 'echo auto-removing $@; rm $@' EXIT; \
1284         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1285           sed -e 's/\\@/@/g' > $@; \
1286         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1287         $(CHECK_MAN_DASHES) $@; \
1288         trap - EXIT
1289
1290 man/%.html.in: man/%.gen man/footer.rst
1291         @test -n "$(PANDOC)" || \
1292           { echo 'pandoc' not found during configure; exit 1; }
1293         set -o pipefail ; \
1294         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1295           sed -e 's/\\@/@/g' > $@
1296
1297 man/%: man/%.in  $(REPLACE_VARS_SED)
1298         sed -f $(REPLACE_VARS_SED) < $< > $@
1299
1300 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1301         sed -f $(REPLACE_VARS_SED) < $< > $@
1302
1303 vcs-version:
1304         if test -d .git; then \
1305           git describe > $@; \
1306         elif test ! -f $@ ; then \
1307           echo "Cannot auto-generate $@ file"; exit 1; \
1308         fi
1309
1310 .PHONY: clean-vcs-version
1311 clean-vcs-version:
1312         rm -f vcs-version
1313
1314 .PHONY: regen-vcs-version
1315 regen-vcs-version:
1316         @set -e; \
1317         cd $(srcdir); \
1318         if test -d .git; then \
1319           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1320           git describe > $$T; \
1321           if ! cmp --quiet $$T vcs-version; then \
1322             mv $$T vcs-version; \
1323           fi; \
1324         fi
1325
1326 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1327         vcs-version $(built_base_sources)
1328         set -e; \
1329         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1330         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1331
1332 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1333         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1334         lib/jstore.py $(RUN_IN_TEMPDIR) \
1335         $(CONVERT_CONSTANTS) $(built_base_sources) \
1336         | lib/_vcsversion.py
1337         set -e; \
1338         { cat $< ; \
1339           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1340         } > $@
1341
1342 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1343         $(built_base_sources)
1344         set -e; \
1345         { cat $< ; \
1346           echo ; \
1347           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1348             echo "import $$name ()" ; \
1349           done ; \
1350         } > $@
1351
1352 lib/_autoconf.py: Makefile | stamp-directories
1353         set -e; \
1354         { echo '# This file is automatically generated, do not edit!'; \
1355           echo '#'; \
1356           echo ''; \
1357           echo '"""Build-time configuration for Ganeti.'; \
1358           echo '';\
1359           echo 'This file is autogenerated by the build process.'; \
1360           echo 'For any changes you need to re-run ./configure (and'; \
1361           echo 'not edit by hand).'; \
1362           echo ''; \
1363           echo '"""'; \
1364           echo ''; \
1365           echo '# pylint: disable=C0301,C0324'; \
1366           echo '# because this is autogenerated, we do not want'; \
1367           echo '# style warnings' ; \
1368           echo ''; \
1369           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1370           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1371           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1372           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1373           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1374           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1375           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1376           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1377           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1378           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1379           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1380           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1381           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1382           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1383           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1384           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1385           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1386           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1387           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1388           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1389           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1390           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1391           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1392           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1393           echo "KVM_PATH = '$(KVM_PATH)'"; \
1394           echo "IP_PATH = '$(IP_PATH)'"; \
1395           echo "SOCAT_PATH = '$(SOCAT)'"; \
1396           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1397           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1398           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1399           echo "TOOLSDIR = '$(toolsdir)'"; \
1400           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1401           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1402           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1403           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1404           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1405           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1406           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1407           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1408           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1409           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1410           echo "RAPI_USER = '$(RAPI_USER)'"; \
1411           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1412           echo "CONFD_USER = '$(CONFD_USER)'"; \
1413           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1414           echo "NODED_USER = '$(NODED_USER)'"; \
1415           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1416           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1417           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1418           echo "HTOOLS = True"; \
1419           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1420           echo "XEN_CMD = '$(XEN_CMD)'"; \
1421           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1422           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1423           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1424 ## Write dictionary with man page name as the key and the section number as the
1425 ## value
1426           echo "MAN_PAGES = {"; \
1427           for i in $(notdir $(man_MANS)); do \
1428             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1429           done; \
1430           echo "}"; \
1431         } > $@
1432
1433 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1434         set -e; \
1435         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1436         { echo '# This file is automatically generated, do not edit!'; \
1437           echo '#'; \
1438           echo ''; \
1439           echo '"""Build-time VCS version number for Ganeti.'; \
1440           echo '';\
1441           echo 'This file is autogenerated by the build process.'; \
1442           echo 'For any changes you need to re-run ./configure (and'; \
1443           echo 'not edit by hand).'; \
1444           echo ''; \
1445           echo '"""'; \
1446           echo ''; \
1447           echo '# pylint: disable=C0301,C0324'; \
1448           echo '# because this is autogenerated, we do not want'; \
1449           echo '# style warnings' ; \
1450           echo ''; \
1451           echo "VCS_VERSION = '$$VCSVER'"; \
1452         } > $@
1453
1454 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1455         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1456
1457 $(SHELL_ENV_INIT): Makefile stamp-directories
1458         set -e; \
1459         { echo '# Allow overriding for tests'; \
1460           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1461           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1462           echo; \
1463           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1464           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1465           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1466           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1467           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1468         } > $@
1469
1470 ## Writes sed script to replace placeholders with build-time values. The
1471 ## additional quotes after the first @ sign are necessary to stop configure
1472 ## from replacing those values as well.
1473 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1474         set -e; \
1475         { echo 's#@''PREFIX@#$(prefix)#g'; \
1476           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1477           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1478           echo 's#@''BINDIR@#$(bindir)#g'; \
1479           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1480           echo 's#@''LIBDIR@#$(libdir)#g'; \
1481           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1482           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1483           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1484           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1485           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1486           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1487           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1488           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1489           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1490           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1491           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1492           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1493           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1494           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1495           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1496           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1497           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1498           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1499           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1500           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1501           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1502           echo; \
1503           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1504           echo '  r $(SHELL_ENV_INIT)'; \
1505           echo '  d'; \
1506           echo '}'; \
1507         } > $@
1508
1509 # Using deferred evaluation
1510 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1511 daemons/ganeti-watcher: MODULE = ganeti.watcher
1512 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1513 tools/burnin: MODULE = ganeti.tools.burnin
1514 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1515 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1516 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1517 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1518 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1519
1520 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1521         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1522         set -e; \
1523         { echo '#!/usr/bin/python'; \
1524           echo '# This file is automatically generated, do not edit!'; \
1525           echo "# Edit $(MODULE) instead."; \
1526           echo; \
1527           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1528           echo; \
1529           echo '# pylint: disable=C0103'; \
1530           echo '# C0103: Invalid name'; \
1531           echo; \
1532           echo 'import sys'; \
1533           echo 'import $(MODULE) as main'; \
1534           echo; \
1535           echo '# Temporarily alias commands until bash completion'; \
1536           echo '# generator is changed'; \
1537           echo 'if hasattr(main, "commands"):'; \
1538           echo '  commands = main.commands # pylint: disable=E1101'; \
1539           echo 'if hasattr(main, "aliases"):'; \
1540           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1541           echo; \
1542           echo 'if __name__ == "__main__":'; \
1543           echo '  sys.exit(main.Main())'; \
1544         } > $@
1545         chmod u+x $@
1546
1547 $(HS_BUILT_TEST_HELPERS): Makefile
1548         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1549         set -e; \
1550         { echo '#!/bin/sh'; \
1551           echo '# This file is automatically generated, do not edit!'; \
1552           echo "# Edit Makefile.am instead."; \
1553           echo; \
1554           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1555         } > $@
1556         chmod u+x $@
1557
1558 stamp-directories: Makefile
1559         $(MAKE) $(AM_MAKEFLAGS) ganeti
1560         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1561         touch $@
1562
1563 # We need to create symlinks because "make distcheck" will not install Python
1564 # files when building.
1565 stamp-srclinks: Makefile | stamp-directories
1566         set -e; \
1567         for i in $(srclink_files); do \
1568           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1569             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1570           fi; \
1571         done
1572         touch $@
1573
1574 .PHONY: ganeti
1575 ganeti:
1576         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1577
1578 .PHONY: check-dirs
1579 check-dirs: $(GENERATED_FILES)
1580         @set -e; \
1581         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1582           error=; \
1583           while read dir; do \
1584             case "$$dir" in \
1585               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1586               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1587             esac; \
1588           done; \
1589           for dir in $(DIRS); do \
1590             if ! test -d "$$dir"; then \
1591               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1592               error=1; \
1593             fi \
1594           done; \
1595           test -z "$$error"; \
1596         }
1597
1598 .PHONY: check-local
1599 check-local: check-dirs $(GENERATED_FILES)
1600         $(CHECK_PYTHON_CODE) $(check_python_code)
1601         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1602         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1603         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1604         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1605         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1606         error= ; \
1607         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1608           echo "Incorrect version in README, expected $$expver" >&2; \
1609           error=1; \
1610         fi; \
1611         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1612             doc/security.rst; do \
1613           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1614             "Documents Ganeti version $$expver"; then \
1615             echo "Incorrect version in $$file, expected $$expver" >&2; \
1616             error=1; \
1617           fi; \
1618         done; \
1619         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1620           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1621           error=1; \
1622         fi; \
1623         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1624           ".. Last updated for Ganeti $$expver"; then \
1625           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1626           error=1; \
1627         fi; \
1628         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1629           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1630             echo "Longest line in $$file is longer than 80 characters" >&2; \
1631             error=1; \
1632           fi; \
1633         done; \
1634         test -z "$$error"
1635
1636 .PHONY: hs-tests
1637 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1638         @rm -f htest.tix
1639         ./test/hs/htest
1640
1641 .PHONY: hs-shell
1642 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1643         @rm -f hpc-htools.tix hpc-mon-collector.tix
1644         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1645
1646 .PHONY: hs-check
1647 hs-check: hs-tests hs-shell
1648
1649 # E111: indentation is not a multiple of four
1650 # E121: continuation line indentation is not a multiple of four
1651 #       (since our indent level is not 4)
1652 # E125: continuation line does not distinguish itself from next logical line
1653 #       (since our indent level is not 4)
1654 # E127: continuation line over-indented for visual indent
1655 #       (since our indent level is not 4)
1656 # note: do NOT add E128 here; it's a valid style error in most cases!
1657 # I've seen real errors, but also some cases were we indent wrongly
1658 # due to line length; try to rework the cases where it is triggered,
1659 # instead of silencing it
1660 # E261: at least two spaces before inline comment
1661 # E501: line too long (80 characters)
1662 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1663
1664 # For excluding pep8 expects filenames only, not whole paths
1665 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1666
1667 LINT_TARGETS = pylint pylint-qa
1668 if HAS_PEP8
1669 LINT_TARGETS += pep8
1670 endif
1671 if HAS_HLINT
1672 LINT_TARGETS += hlint
1673 endif
1674
1675 .PHONY: lint
1676 lint: $(LINT_TARGETS)
1677
1678 .PHONY: pylint
1679 pylint: $(GENERATED_FILES)
1680         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1681         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1682
1683 .PHONY: pylint-qa
1684 pylint-qa: $(GENERATED_FILES)
1685         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1686         cd $(top_srcdir)/qa && \
1687           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1688           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1689
1690 .PHONY: pep8
1691 pep8: $(GENERATED_FILES)
1692         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1693         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1694           --repeat $(pep8_python_code)
1695
1696 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1697 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1698 .PHONY: hlint
1699 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1700         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1701         if tty -s; then C="-c"; else C=""; fi; \
1702         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1703           --ignore "Use first" \
1704           --ignore "Use &&&" \
1705           --ignore "Use void" \
1706           --ignore "Reduce duplication" \
1707           --hint src/lint-hints \
1708           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1709
1710 # a dist hook rule for updating the vcs-version file; this is
1711 # hardcoded due to where it needs to build the file...
1712 dist-hook:
1713         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1714         rm -f $(top_distdir)/vcs-version
1715         cp -p $(srcdir)/vcs-version $(top_distdir)
1716
1717 # a distcheck hook rule for catching revision control directories
1718 distcheck-hook:
1719         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1720           echo "Found revision control files in final archive." 1>&2; \
1721           exit 1; \
1722         fi
1723         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1724           echo "Found Python byte code in final archive." 1>&2; \
1725           exit 1; \
1726         fi
1727         if find $(top_distdir) -name '*~' | grep .; then \
1728           echo "Found backup files in final archive." 1>&2; \
1729           exit 1; \
1730         fi
1731 # Empty files or directories should not be distributed. They can cause
1732 # unnecessary warnings for packagers. Directories used by automake during
1733 # distcheck must be excluded.
1734         if find $(top_distdir) -empty -and -not \( \
1735             -path $(top_distdir)/_build -or \
1736             -path $(top_distdir)/_inst \) | grep .; then \
1737           echo "Found empty files or directories in final archive." 1>&2; \
1738           exit 1; \
1739         fi
1740         if test -n "$(BUILD_RELEASE)" && \
1741            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1742            echo "Found unreleased version in NEWS." >&2; \
1743            exit 1; \
1744         fi
1745         if test -e $(top_distdir)/doc/man-html; then \
1746           echo "Found documentation including man pages in final archive" >&2; \
1747           exit 1; \
1748         fi
1749
1750 # When building a release, stricter checks should be used
1751 distcheck-release dist-release: export BUILD_RELEASE = 1
1752 distcheck-release: distcheck
1753
1754 distrebuildcheck: dist
1755         set -e; \
1756         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1757         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1758         cd $$builddir; \
1759         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1760         cd $(distdir); \
1761         ./configure; \
1762         $(MAKE) maintainer-clean; \
1763         cp $(abs_srcdir)/vcs-version .; \
1764         ./configure; \
1765         $(MAKE) $(AM_MAKEFLAGS)
1766
1767 dist-release: dist
1768         set -e; \
1769         for i in $(DIST_ARCHIVES); do \
1770           echo -n "Checking $$i ... "; \
1771           autotools/check-tar < $$i; \
1772           echo OK; \
1773         done
1774
1775 install-exec-local:
1776         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1777           "$(DESTDIR)${localstatedir}/log/ganeti" \
1778           "$(DESTDIR)${localstatedir}/run/ganeti"
1779
1780 .PHONY: apidoc
1781 if WANT_HSAPIDOC
1782 apidoc: py-apidoc hs-apidoc
1783 else
1784 apidoc: py-apidoc
1785 endif
1786
1787 .PHONY: py-apidoc
1788 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1789         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1790         $(RUN_IN_TEMPDIR) epydoc -v \
1791           --conf $(CURDIR)/epydoc.conf \
1792           --output $(CURDIR)/$(APIDOC_PY_DIR)
1793
1794 .PHONY: hs-apidoc
1795 hs-apidoc: $(HS_BUILT_SRCS)
1796         @test -n "$(HSCOLOUR)" || \
1797             { echo 'HsColour' not found during configure; exit 1; }
1798         @test -n "$(HADDOCK)" || \
1799             { echo 'haddock' not found during configure; exit 1; }
1800         rm -rf $(APIDOC_HS_DIR)/*
1801         for i in $(ALL_APIDOC_HS_DIRS); do \
1802           @mkdir_p@ $$i; \
1803         done
1804         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1805         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1806         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1807         set -e ; \
1808         cd src; \
1809         if [ "$(HS_NOCURL)" ]; \
1810         then OPTGHC="--optghc=$(HS_NOCURL)"; \
1811         else OPTGHC=""; \
1812         fi; \
1813         if [ "$(HS_PARALLEL3)" ]; \
1814         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1815         fi; \
1816         if [ "$(HS_REGEX_PCRE)" ]; \
1817         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1818         fi; \
1819         RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
1820         for file in $$RELSRCS; do \
1821           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1822           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1823         done ; \
1824         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1825           -t ganeti -p haddock-prologue \
1826           --source-module="%{MODULE/.//}.html" \
1827           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1828           $$OPTGHC \
1829           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
1830
1831 .PHONY: TAGS
1832 TAGS: $(GENERATED_FILES)
1833         rm -f TAGS
1834         $(GHC) -e ":etags" -v0 \
1835           $(filter-out -O -Werror,$(HFLAGS)) \
1836           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1837           $(HS_LIBTEST_SRCS)
1838         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1839           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1840           -path './qa/*.py' | \
1841           etags -l python -a -
1842
1843 .PHONY: coverage
1844 if WANT_HTOOLS
1845 coverage: py-coverage hs-coverage
1846 else
1847 coverage: py-coverage
1848 endif
1849
1850 .PHONY: py-coverage
1851 py-coverage: $(GENERATED_FILES) $(python_tests)
1852         @test -n "$(PYCOVERAGE)" || \
1853             { echo 'python-coverage' not found during configure; exit 1; }
1854         set -e; \
1855         COVERAGE=$(PYCOVERAGE) \
1856         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1857         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1858         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1859         $(PLAIN_TESTS_ENVIRONMENT) \
1860         $(abs_top_srcdir)/autotools/gen-py-coverage \
1861         $(python_tests)
1862
1863 .PHONY: hs-coverage
1864 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1865         rm -f *.tix
1866         $(MAKE) $(AM_MAKEFLAGS) hs-check
1867         @mkdir_p@ $(COVERAGE_HS_DIR)
1868         hpc sum --union $(HPCEXCL) \
1869           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1870         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1871         hpc report coverage-hs.tix
1872         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1873
1874 # Special "kind-of-QA" target for htools, needs special setup (all
1875 # tools compiled with -fhpc)
1876 .PHONY: live-test
1877 live-test: all
1878         set -e ; \
1879         cd src; \
1880         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1881         rm -f *.tix *.mix; \
1882         ./live-test.sh; \
1883         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1884           --output=live-test.tix ; \
1885         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1886         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1887           --srcdir=.. $(HPCEXCL) ; \
1888         hpc report --srcdir=.. live-test $(HPCEXCL)
1889
1890 commit-check: distcheck lint apidoc
1891
1892 .PHONY: gitignore-check
1893 gitignore-check:
1894         @if [ -n "`git status --short`" ]; then \
1895           echo "Git status is not clean!" 1>&2 ; \
1896           git status --short; \
1897           exit 1; \
1898         fi
1899
1900 # target to rebuild all man pages (both groff and html output)
1901 .PHONY: man
1902 man: $(man_MANS) $(manhtml)
1903
1904 # Target that builds all binaries (including those that are not
1905 # rebuilt except when running the tests)
1906 .PHONY: really-all
1907 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1908
1909 # we don't need the ancient implicit rules:
1910 %: %,v
1911 %: RCS/%,v
1912 %: RCS/%
1913 %: s.%
1914 %: SCCS/s.%
1915
1916 -include ./Makefile.local
1917
1918 # vim: set noet :